/*
 * caltree.cpp
 *
 *  Created on: Jan 14, 2009
 *      Author: qwan
 */
#include "caltree.h"

int CalNode::cnt = 0;

void CalTree::insert(int pts_id, Pt_Collection* r) {

	CalNode* ptr = root;
	Pt_Collection* region = new Pt_Collection(*r);

	list<CalNode*>::iterator i;

	// find the insert position
	while (!region->empty() && ptr->children_list.size() != 0) {
		Pt_Collection* tp = NULL;
		CalNode* ptr2 = ptr;

		for (i = ptr->children_list.begin(); i != ptr->children_list.end(); ++i) {
			if (includes(region->begin(), region->end(),
					(*i)->parent_path->begin(), (*i)->parent_path->end())) {
				ptr2 = *i;
				tp = new Pt_Collection;
				set_difference(region->begin(), region->end(),
						(*i)->parent_path->begin(), (*i)->parent_path->end(),
						::inserter((*tp), (*tp).begin()));
				delete region;
				region = tp;
				break;
			}
		}

		if (ptr == ptr2) {
			break;
		} else {
			ptr = ptr2;
		}
	}

	if (region->empty()) {
		ptr->pts.push_back(pts_id);
		return;
	}

	Pt_Collection* max = NULL;
	int maxsize = 0;

	list<CalNode*>::iterator maxit;

	//find the remaining overlap
	for (i = ptr->children_list.begin(); i != ptr->children_list.end(); ++i) {

		Pt_Collection* tp = new Pt_Collection;

		set_intersection(region->begin(), region->end(),
				(*i)->parent_path->begin(), (*i)->parent_path->end(),
				::inserter((*tp), (*tp).begin()));

		if ((*tp).size() > maxsize) {
			if (max != NULL) {
				delete max;
			}
			maxsize = (*tp).size();
			max = tp;
			maxit = i;
		} else {
			delete tp;
		}
	}

	if (maxsize == 0) { //no overlap can be found, make a new node here as a child of ptr
		CalNode* pNode = new CalNode;
		pNode->pts.push_back(pts_id);
		pNode->parent_path = region;
		ptr->children_list.push_back(pNode);
	} else {//choose the largest overlap to insert, split into two part max and region - max;
		Pt_Collection* setdiff = new Pt_Collection;
		set_difference(region->begin(), region->end(), max->begin(),
				max->end(), ::inserter((*setdiff), (*setdiff).begin()));

		//insert father node
		CalNode* pNode = new CalNode;
		pNode->parent_path = max;
		ptr->children_list.push_back(pNode);

		CalNode* oldNode = pNode;

		if (setdiff->size() != 0) {
			//insert itself
			pNode = new CalNode;
			pNode->pts.push_back(pts_id);
			pNode->parent_path = setdiff;
			oldNode->children_list.push_back(pNode);
		} else {
			delete setdiff;
			pNode->pts.push_back(pts_id);
		}

		//insert brothers;
		CalNode* brNode = (*maxit);
		ptr->children_list.erase(maxit);
		setdiff = new Pt_Collection;
		set_difference(brNode->parent_path->begin(),
				brNode->parent_path->end(), max->begin(), max->end(),
				::inserter((*setdiff), (*setdiff).begin()));
		delete brNode->parent_path;
		brNode->parent_path = setdiff;
		oldNode->children_list.push_back(brNode);

	}

}

void CalTree::tmpFreeTree() {
	stack<CalNode*>* nodeStack = new stack<CalNode*> ;
	nodeStack->push(root);

	while (!nodeStack->empty()) {
		CalNode* tp = nodeStack->top();
		nodeStack->pop();
		list<CalNode*>::iterator i;
		for (i = tp->children_list.begin(); i != tp->children_list.end(); i++) {
			nodeStack->push(*i);
		}
		delete tp->formula;
		tp->formula = NULL;
	}
	delete nodeStack;
}
