/*
 * main.cpp
 *
 *  Created on: Oct 30, 2008
 *      Author: qwan
 */

//#define DEBUG;
#include "skyline.h"
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <math.h>
#include <time.h>
#include "CSet.h"
#include "CSkyV2.h"

#define BILLION  1000000000L;

int tableNum;
int split_num;
int threhold;
int c = 0;
int c2 = 0;
int al;
bool calbnl = true;

PtsSpace* tables;
vector<int>* rule;
PtsSpace** m;
int* grouping;
vector<int *> result;
vector<int> oldv;

//struct timespec start1, start2, stop;

float userTime_read, sysTime_read;
float userTime_prep, sysTime_prep;
float userTime_algo, sysTime_algo;
float userTime_bnl, sysTime_bnl;
float userTime_overall, sysTime_overall;
struct rusage myTime_program_start, myTime_read_end, myTime_prep_end,
		myTime_bnl_end, myTime_algo_end;

int load() {
	//open file
	FILE * pFile;
	if ((pFile = fopen("./config", "r")) == NULL) {
		printf("reading error!!!");
		//exit(0);
		return 0;
	}
	//get number of tables
	fscanf(pFile, "%d", &tableNum);

	//Object "tables" stores all table in this program
	//load config for tables
	tables = new PtsSpace[tableNum];
	tables[0].isPackage = true;

	char* fileName = new char[100];
	FILE** fArray = new FILE*[tableNum];

	int tup = 0;

	for (int i = 0; i < tableNum; i++) {
		sprintf(fileName, "table%d_skyline", i);
		if ((fArray[i] = fopen(fileName, "r")) == NULL) {
			sprintf(fileName, "table%d", i);
			if ((fArray[i] = fopen(fileName, "r")) == NULL) {
				printf("data reading error!!!");
				return 0;
			}
		} else {
			fscanf(fArray[i], "%d\n", &tup);
			calbnl = false;
		}

	}

	int d, t, n;

	fscanf(pFile, "%d%d%d", &d, &t, &n);
	if (tup == 0) {
		tables[0].init(d, t, n);
	} else {
		tables[0].init(d, tup, n);
	}

	for (int i = 1; i < tableNum; i++) {
		fscanf(pFile, "%d%d%d", &d, &t, &n);
		tables[i].init(d, t, n);
	}

	//load rules
	int dim = tables[0].dimNum;
	rule = new vector<int> [dim];

	for (int i = 0; i < dim; i++) {
		fscanf(pFile, "%d", &d);
		rule[i].resize(2 * d);
	}

	//transform the rule for future convenience
	// n is table index and n+1 is dim index
	for (int i = 0; i < dim; i++) {
		for (int j = 0; j < rule[i].size(); j++) {
			fscanf(pFile, "%d", &rule[i][j]);
			if (j % 2 == 1) {
				tables[rule[i][j - 1]].f[rule[i][j]] = i;
			}
		}
	}

	fclose(pFile);

	//load table data

	printf("start loading.....\n");

	for (int l = 0; l < tableNum; l++) { //l-th table
		tables[l].getdata(fArray[l]);
		fclose(fArray[l]);
	}

	//tables[0].show();

	return 1;
}

void timetofile(struct timespec stop, struct timespec start, FILE * f) {
	double accum = (stop.tv_sec - start.tv_sec) + (double) (stop.tv_nsec
			- start.tv_nsec) / (double) BILLION;
	fprintf(f, "\n%lf", accum);
}

void calculateExecutionTime(struct rusage *myTimeStart,
		struct rusage *myTimeEnd, float *userTime, float *sysTime) {
	(*userTime) = ((float) (myTimeEnd->ru_utime.tv_sec
			- myTimeStart->ru_utime.tv_sec))
			+ ((float) (myTimeEnd->ru_utime.tv_usec
					- myTimeStart->ru_utime.tv_usec)) * 1e-6;
	(*sysTime) = ((float) (myTimeEnd->ru_stime.tv_sec
			- myTimeStart->ru_stime.tv_sec))
			+ ((float) (myTimeEnd->ru_stime.tv_usec
					- myTimeStart->ru_stime.tv_usec)) * 1e-6;

}

void printTimeFile() {

	FILE *filePtr;
	//	char *filename = "time";

	filePtr = (FILE *) fopen("time_sk", "w");
	if (filePtr == NULL) {
		printf("File cannot be opened in printTime!\n");
		exit(0);
	}

	// output execution time
	calculateExecutionTime(&myTime_program_start, &myTime_read_end,
			&userTime_read, &sysTime_read);
	calculateExecutionTime(&myTime_read_end, &myTime_prep_end, &userTime_prep,
			&sysTime_prep);
	calculateExecutionTime(&myTime_prep_end, &myTime_algo_end, &userTime_algo,
			&sysTime_algo);
	calculateExecutionTime(&myTime_program_start, &myTime_bnl_end,
			&userTime_overall, &sysTime_overall);
	calculateExecutionTime(&myTime_algo_end, &myTime_bnl_end, &userTime_bnl,
			&sysTime_bnl);

	// reading time
	fprintf(filePtr, "%.10f %.10f\n", userTime_read, sysTime_read);

	// sorting time
	fprintf(filePtr, "%.10f %.10f\n", userTime_prep, sysTime_prep);

	// writing time
	fprintf(filePtr, "%.10f %.10f\n", userTime_algo, sysTime_algo);

	fprintf(filePtr, "%.10f %.10f\n", userTime_bnl, sysTime_bnl);

	// overall time
	fprintf(filePtr, "%.10f %.10f\n", userTime_overall, sysTime_overall);

	fclose(filePtr);
}

void calM() {
	for (int i = 0; i < tableNum - 1; i++) {
		for (int j = 0; j < split_num; j++) {
			m[i][j].calM();
		}
	}
}

void Prep() {
	for (int i = 0; i < tableNum - 1; i++) {
		for (int j = 0; j < grouping[i]; j++) {
			m[i][j].calM();
			m[i][j].store();
			m[i][j].minusMin();
			m[i][j].build_index();
			m[i][j].restore();
		}
	}
}

Pt_Collection* worstRegion(vector<int>& v) {

	int* q = new int[tables[0].dimNum];
	int* zero = new int[tables[0].dimNum];

	memset(zero, 0, sizeof(int) * tables[0].dimNum);
	memset(q, 0, sizeof(int) * tables[0].dimNum);

	for (int i = 0; i < tables[0].dimNum; i++) {
		if (i >= tables[0].nonMerg) {
			for (int j = 0; j < rule[i].size(); j += 2) {
				int t = rule[i][j] - 1;
				int d = rule[i][j + 1];
				q[i] += m[t][v[t]].M[d];
			}
		} else {
			int t = rule[i][0] - 1;
			int d = rule[i][1];
			q[i] = m[t][v[t]].M[d];
		}
	}

	Pt_Collection* re = tables[0].rect_query(zero, q);

	delete[] zero;
	delete[] q;

	return re;

}

Pt_Collection* bestRegion(vector<int>& v) {

	int* q = new int[tables[0].dimNum];
	int* zero = new int[tables[0].dimNum];

	memset(zero, 0, sizeof(int) * tables[0].dimNum);
	memset(q, 0, sizeof(int) * tables[0].dimNum);

	for (int i = 0; i < tables[0].dimNum; i++) {
		if (i >= tables[0].nonMerg) {
			for (int j = 0; j < rule[i].size(); j += 2) {
				int t = rule[i][j] - 1;
				int d = rule[i][j + 1];
				q[i] += m[t][v[t]].min[d];
			}
		} else {
			int t = rule[i][0] - 1;
			int d = rule[i][1];
			q[i] = m[t][v[t]].min[d];
		}
	}

	for (int i = 0; i < tables[0].dimNum; i++) {
		printf("%d ", q[i]);
	}
	printf("\n");

	Pt_Collection* re = tables[0].rect_query(zero, q);

	delete[] q;
	delete[] zero;

	return re;
}

bool checkbestRegion(vector<int>& v) {

	int* q = new int[tables[0].dimNum];

	memset(q, 0, sizeof(int) * tables[0].dimNum);

	for (int i = 0; i < tables[0].dimNum; i++) {
		if (i >= tables[0].nonMerg) {
			for (int j = 0; j < rule[i].size(); j += 2) {
				int t = rule[i][j] - 1;
				int d = rule[i][j + 1];
				q[i] += m[t][v[t]].min[d];
			}
		} else {
			int t = rule[i][0] - 1;
			int d = rule[i][1];
			q[i] = m[t][v[t]].min[d];
		}
	}

	bool re = tables[0].rect_checking(q);

	delete[] q;

	return !re;

}

double est_time(int pSize, int tSize, int tNum, int pdim, int tdim, double pre) {
	double size = pow(tSize * tdim / 1000.0, tNum) * log(pSize * pdim);
	return pre + size;
}

double est_pre_time(int pSize, int tSize, int tNum) {
	double size = pSize * log(pSize) / 3000.0 + tNum * tSize * log(tSize)
			/ 3000.0;
	return size;
}

void algo2() {
	/*
	 skyline* sky = new skyline();
	 sky->setAlgo2(tables,rule,tableNum);
	 sky->iter_thd = threhold;
	 sky->preprocessing();
	 //running..........
	 sky->run();
	 delete sky;
	 */

	naive* na = new naive();

	na->tableNum = tableNum;

	//PtsSpace* p = tables[0]->Product(NCR[i]);
	//na->tables.push_back(p);

	//PtsSpace* f = tables[1]->ProductOrg(i);

	//na->tables.push_back(f);

	for (int j = 0; j < tableNum; j++) {
		na->tables.push_back(&tables[j]);
	}

	na->run();

}

void algo1() {

	m = new PtsSpace*[tableNum - 1];

	for (int i = 0; i < tableNum - 1; i++) {
		m[i] = tables[i + 1].split(split_num);
	}

	calM();

	vector<int> v;
	vector<PtsSpace*> vp;

	v.push_back(0);

	while (!v.empty()) {
		if (v.back() == split_num) {
			v.pop_back();
			if (v.size() > 0) {
				v[v.size() - 1]++;
			}
		} else {
			if (v.size() < tableNum - 1) {
				v.push_back(0);
			} else {

				Pt_Collection* best = bestRegion(v);
				int count = v[0];
				for (int j = 1; j < tableNum - 1; j++) {
					count = count * split_num + v[j];
				}

				double rate = count / pow(split_num, tableNum - 1) * 100.0;

				printf("%lf percents is finished\n", rate);

				if (best->size() != 0) {
					delete best;
					c2++;
				} else {
					delete best;

					for (int j = 0; j < tableNum - 1; j++) {
						vp.push_back(&m[j][v[j]]);
					}

					skyline* sky = new skyline();
					PtsSpace* p;

					Pt_Collection* worst = worstRegion(v);
					int res = worst->size();
					//delete worst;

					if (res < 1000 && (res < (tables[0].tupleNum / threhold))) {
						c++;
						p = tables[0].Product(worst);

						p->build_index();
						p->sampling();

						sky->setAlgo(p, vp, rule, tableNum);

						sky->preprocessing();
						//running..........
						sky->run();

						delete worst;
						delete sky;
						delete p;
					} else {
						sky->setAlgo(&tables[0], vp, rule, tableNum);
						sky->preprocessing();
						//running..........
						sky->run();
						delete sky;
					}
				}

				vp.clear();
				v[v.size() - 1]++;

			}
		}

	}
}

void algo3() {

	tables[1].kmp();

	m = new PtsSpace*[tableNum - 2];
	for (int i = 0; i < tableNum - 2; i++) {
		m[i] = tables[i + 2].split(split_num);
	}

	calM();

	for (int i = 0; i < tableNum - 2; i++) {
		for (int j = 0; j < split_num; j++) {
			m[i][j].calM();
		}
	}

	getrusage(RUSAGE_SELF, &myTime_prep_end);

	vector<int> v;
	vector<PtsSpace*> vp;

	v.push_back(0);

	while (!v.empty()) {
		if (v.back() == split_num) {
			v.pop_back();
			if (v.size() > 0) {
				v[v.size() - 1]++;
			}
		} else {
			if (v.size() < tableNum - 2) {
				v.push_back(0);
			} else {
				int count = v[0];
				int count2 = v[0];
				for (int j = 1; j < tableNum - 2; j++) {
					count = count * split_num + v[j];
					count2 += v[j];
				}

				int avg = count2 / (tableNum - 2);

				double rate = count / pow(split_num, tableNum - 2) * 100.0;

				printf("%lf percents is finished\n", rate);

				vp.push_back(&tables[1]);

				for (int j = 0; j < tableNum - 2; j++) {
					vp.push_back(&m[j][v[j]]);
				}

				skyline* sky = new skyline();

				sky->setAlgo(&tables[0], vp, rule, tableNum);

				if (avg > split_num / 3 * 2) {
					//sky->iter_thd = threhold ;
					sky->preprocessing2();
				} else {
					//sky->iter_thd = threhold + 1;
					sky->preprocessing();
				}

				//running..........
				sky->run();
				delete sky;

				vp.clear();
				v[v.size() - 1]++;

			}
		}

	}
}

void pruning() {

	Pt_Collection* ncr;
	Pt_Collection s;

	int* v1 = new int[tables[0].dimNum];
	int* v2 = new int[tables[0].dimNum];

	for (int i = 1; i < tableNum; i++) {
		tables[i].calM();
	}

	for (int k = 1; k < tableNum; k++) {

		for (int i = 0; i < tables[k].tupleNum; i++) {

			for (int j = 0; j < tables[0].dimNum; j++) {
				v1[j] = _MAXIMUM;
				v2[j] = 0;
			}

			for (int j = 0; j < tables[k].nonMerg; j++) {
				v1[tables[k].f[j]] = tables[k].v[i][j];
			}

			for (int j = tables[k].nonMerg; j < tables[k].dimNum; j++) {
				int pidx = tables[k].f[j];
				v1[pidx] = tables[k].v[i][j];

				for (int n = 0; n < rule[pidx].size(); n += 2) {
					int t = rule[pidx][n];
					int d = rule[pidx][n + 1];
					if (t != k) {
						v1[pidx] += tables[t].M[d];
					}
				}
			}

			ncr = tables[0].rect_query(v2, v1);
			if (ncr->size() == 0) {
				//printf("hit!!");
				s.insert(i);
			}

			delete ncr;

		}

		tables[k].remove(s);
		tables[k].calM();

		long mt = s.size();

		for (int i = 1; i < tableNum; i++) {
			if (i != k) {
				mt *= tables[i].tupleNum;
			}
		}

		skyline::skyline_count += mt;
		skyline::pruning1 += mt;

		s.clear();

	}

	delete[] v1;
	delete[] v2;

}

int main2(int argc, char** argv) {

	srand(time(0));

	if (argc != 4) {
		printf(
				"wrong options!!!, 3 needed, say <split option> <split num> <recalculate threhold>");
		return 0;
	} else {
		al = atoi(argv[1]);
		split_num = atoi(argv[2]);
		threhold = atoi(argv[3]);
	}

	FILE* f = fopen("stat", "w+");

	getrusage(RUSAGE_SELF, &myTime_program_start);

	//preprocessing...................
	load();

	for (int i = 0; i < tableNum; i++) {
		tables[i].bnl();
	}

	if (tables[2].tupleNum / split_num > 2000) {
		split_num = tables[2].tupleNum / 2000;
	}

	getrusage(RUSAGE_SELF, &myTime_read_end);

	tables[0].build_index();

	long mt = 1;
	for (int i = 0; i < tableNum; i++) {
		fprintf(f, "%d ", tables[i].tupleNum);
		if (i != 0) {
			mt *= tables[i].tupleNum;
		}
	}

	fprintf(f, "%ld ", mt);

	pruning();

	getrusage(RUSAGE_SELF, &myTime_prep_end);

	if (al == 0) {
		algo1();
		for (int i = 0; i < tableNum - 1; i++) {
			delete[] m[i];
		}

	} else if (al == 1) {
		algo2();
	} else if (al == 2) {
		algo3();
		for (int i = 0; i < tableNum - 2; i++) {
			delete[] m[i];
		}
	}

	getrusage(RUSAGE_SELF, &myTime_algo_end);

	fprintf(f, "%ld ", PtsSpace::totalAsked);
	fprintf(f, "%ld ", skyline::skyline_count);
	fprintf(f, "%ld ", skyline::pruning1);
	fprintf(f, "%ld ", skyline::pruning2);
	fprintf(f, "%ld ", skyline::pruning3);
	fprintf(f, "%ld ", mt - PtsSpace::totalAsked - skyline::pruning1
			- skyline::pruning3);
	fprintf(f, "%ld", skyline::memmax);

	printTimeFile();

	fclose(f);

	delete[] m;

	delete[] tables;
	delete[] rule;

	return EXIT_SUCCESS;

}

void prep_pack(vector<int>& v) {
	//tables[0].restore();
	if (oldv.size() != 0) {
		for (int i = 0; i < tableNum - 1; i++) {
			if (oldv[i] != v[i]) {
				int k = v[i];
				int o = oldv[i];
				for (int j = m[i][k].nonMerg; j < m[i][k].dimNum; j++) {
					int min = m[i][k].min[j] - m[i][o].min[j];
					for (int p = 0; p < tables[0].tupleNum; p++) {
						tables[0].v[p][m[i][k].f[j]] -= min;
					}
				}
			}
		}
	} else {
		for (int i = 0; i < tableNum - 1; i++) {
			int k = v[i];
			for (int j = m[i][k].nonMerg; j < m[i][k].dimNum; j++) {
				int min = m[i][k].min[j];
				for (int p = 0; p < tables[0].tupleNum; p++) {
					tables[0].v[p][m[i][k].f[j]] -= min;
				}
			}
		}
	}

	oldv = v;
}

void algo5() {

	grouping = new int[tableNum - 1];

	if (calbnl) {
		for (int i = 0; i < tableNum; i++) {
			tables[i].bnl();
		}

		tables[0].tofile("table0_skyline");
	} else {

		for (int i = 1; i < tableNum; i++) {
			tables[i].bnl();
		}

	}

	int partnum = tables[1].tupleNum / split_num;
	int spn = (int) floor(partnum / 2);
	int spm = 2;

	if (spn < 2) {
		spn = 2;
	}

	m = new PtsSpace*[tableNum - 1];
	for (int i = 1; i < tableNum; i++) {
		if (i != 1) {
			m[i - 1] = tables[i].split(spn, spm, &grouping[i - 1]);
		} else {
			m[i - 1] = tables[i].split(spn, spm, &grouping[i - 1]);
		}

	}

	Prep();
	tables[0].store();
	tables[0].build_index();

	vector<int> v;
	csky* sky = new csky;
	CSet* cs = new CSet;
	sky->cs = cs;

	getrusage(RUSAGE_SELF, &myTime_prep_end);

	v.push_back(0);

	//int count = 0;

	while (!v.empty()) {
		if (v.back() == grouping[v.size() - 1]) {
			v.pop_back();
			if (v.size() > 0) {
				v[v.size() - 1]++;
				if (v.size() == 1) {
					double rate = (v[0] * 100.0) / grouping[0];
					printf("%lf percents is finished, avg is %lf\n", rate,
							sky->avg);
				}
			}
		} else {

			if (v.size() < tableNum - 1) {
				v.push_back(0);
			} else {
				bool best = checkbestRegion(v);

				if (best) {

				} else {
					prep_pack(v);

					sky->tables.push_back(&tables[0]);

					for (int i = 0; i < tableNum - 1; i++) {
						sky->tables.push_back(&m[i][v[i]]);
						//printf("%d %d", v[i],m[i][v[i]].tupleNum);
					}

					sky->tableNum = tableNum;
					sky->run();

					sky->clear();

				}

				v[tableNum - 2]++;

			}
		}

	}

	getrusage(RUSAGE_SELF, &myTime_algo_end);

	//	skyline::memcost += sky->result.size() * tables[0].dimNum * sizeof(int);

	//	PtsSpace* tp = new PtsSpace;
	//
	//	tp->tpinit(tables[0].dimNum,sky->result.size(),tables[0].nonMerg);
	//
	//	for(int i=0;i<sky->result.size();i++){
	//			tp->v[i] = sky->result[i];
	//	}
	//
	//	//tp->tofile("result");
	//
	//	if(tables[0].dimNum > tables[0].nonMerg + 1 ){
	//
	//		tp->tofile("temp_result");
	//		printf("%d\n",tp->tupleNum);
	//		tp->bnl();
	//		printf("%d\n",tp->tupleNum);
	//
	//		csky::skyline_count = tp->tupleNum;
	//		tp->tofile("result");
	//
	//	}
	//	else
	//	{
	//		//csky::skyline_count = sky->result.size();
	//	}

}

int main(int argc, char** argv) {
	//
	//	int test[5];
	//	test[0] = 5;
	//	test[1] = 6;
	//	test[2] = 8;
	//	test[3] = 2;
	//	test[4] = 4;
	//
	//	CSet* s = new CSet(5,test);
	//	int* vec = s->remapping(15);
	//	int index = s->mapping(vec);
	//	printf("%d, %d",index, 15);
	//


	split_num = atoi(argv[1]);

	getrusage(RUSAGE_SELF, &myTime_program_start);
	FILE* f = fopen("stat_sk", "w+");

	load();

	getrusage(RUSAGE_SELF, &myTime_read_end);

	long mt0 = 1;
	for (int i = 0; i < tableNum; i++) {
		if (i != 0) {
			mt0 *= tables[i].tupleNum;
		}
	}

	algo5();

	getrusage(RUSAGE_SELF, &myTime_bnl_end);

	long mt1 = 1;
	for (int i = 0; i < tableNum; i++) {
		//fprintf(f,"%d,",tables[i].tupleNum);
		if (i != 0) {
			mt1 *= tables[i].tupleNum;
		}
	}

	fprintf(f, "%ld,", csky::skyline_count);
	fprintf(f, "%ld,", csky::pruned);
	fprintf(f, "%ld,", skyline::memcost + 1000000 * sizeof(char));
	fprintf(f, "%ld,", mt0);
	fprintf(f, "%ld,", mt1);

	printTimeFile();

}

/*

 int main(int argc, char** argv){
 CSet* cs = new CSet;


 while(true){
 PtsSpace* pt = new PtsSpace;
 pt->init(5,2000,3);
 delete pt;

 int* n = new int[1000];

 n[0] = 5;
 n[1] = 7;
 n[2] = 11;

 cs->init(3,n);
 cs->clear();

 }
 }
 */
